//
//      SGRNetworkDialogSet.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.5
//

#ifndef __SGRNETWORKDIALOGSET_HPP
#define __SGRNETWORKDIALOGSET_HPP

#include <SophiaFramework.hpp>
#include "SGRSoftkeyToolbox.hpp"
#include "SGRErrorDialogSet.hpp"

SFMTYPEDEFCLASS(SGRNetworkDialogSet)
class SGRNetworkDialogSet {
    SFMSEALCOPY(SGRNetworkDialogSet)
public:
    enum NotifyEnum {
        NOTIFY_CONNECT_START,
        NOTIFY_CONNECT_CANCEL,
        NOTIFY_CONNECT_END,
        NOTIFY_ERROR
    };
    typedef Void (*NetworkDialogSetSPP)(NotifyEnum, SFCError, VoidPtr);

private:
	Bool					_connecting; 
    SFXHTTPConnection		_http;   
    NetworkDialogSetSPP		_spp;
    VoidPtr					_reference;
    SFRDialogPtr			_dialog;
	SFXAnsiString			_ok;
	SFXAnsiString			_cancel;
	SFXAnsiString			_text;
	SFXAnsiString			_title;
	SFXAnsiString			_asin;
	SFXAnsiString			_string;
    SFXAnsiString			_url;
	SGRErrorDialogSet		_errorDialog;
	SFXFile					_file;					
	SFXBinaryStreamReader	_reader;				
    SFXBinaryStreamWriter	_writer;				
    SFXBuffer				_receivedBuffer;		
    SFXBuffer				_tempBuffer;			
    UInt32					_bufferSize;
	SFXPath					_path;


public:
    SGRNetworkDialogSet(Void);
    virtual ~SGRNetworkDialogSet(Void);
    
	SFCError Open(Bool isConfirm, NetworkDialogSetSPP procedure, VoidPtr data, SFXAnsiStringConstRef title, SFXAnsiStringConstRef text, SFXAnsiStringConstRef ok, SFXAnsiStringConstRef cancel, SFXWideStringConstRef asin);
	SFXAnsiString GetUrlForISBNSsarch(SFXAnsiStringConstRef isbn);

	Bool IsConnecting(Void) { return _connecting;}

	Void ClearData(Void) { _receivedBuffer.Free(); }

private:
	Void Close_Http(Void);
	Void Error_File(Void);
	Void Error_Funciton(SFCError error, SFXAnsiStringConstRef title, SFXAnsiStringConstRef text, SFXAnsiStringConstRef ok, VoidPtr data);

    SFCError Connect(Void);

    HANDLER_DECLARE_VOIDDIALOG(OnDialog)
	HANDLER_DECLARE_VOIDDIALOG(OnReceiving)
	HANDLER_DECLARE_VOIDSUSPEND(OnSuspend)
	HANDLER_DECLARE_VOIDRESUME(OnResume)

	CALLBACK_DECLARE_SFXHTTPCONNECTION(ConnectCallback)
    CALLBACK_DECLARE_SFXBINARYSTREAMREADER(FetchCallback)
};


#endif //__SGRNETWORKDIALOGSET_HPP //
